<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/TypeAnalysis/TypeEvaluator.hh.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/TypeAnalysis/TypeEvaluator.hh</title>
<link href="../../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../../Scopes/global.html" >Global Namespace</a></span>
<span class="normal"><a href="../../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/TypeAnalysis/TypeEvaluator.hh</b><pre class="sxr"><a id="line1"></a><span class="lineno"> 1</span><span class="line"><span class="comment">//</span></span>
<a id="line2"></a><span class="lineno"> 2</span><span class="line"><span class="comment">// Copyright (C) 2005 Stefan Seefeld</span></span>
<a id="line3"></a><span class="lineno"> 3</span><span class="line"><span class="comment">// All rights reserved.</span></span>
<a id="line4"></a><span class="lineno"> 4</span><span class="line"><span class="comment">// Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span></span>
<a id="line5"></a><span class="lineno"> 5</span><span class="line"><span class="comment">// see the file COPYING for details.</span></span>
<a id="line6"></a><span class="lineno"> 6</span><span class="line"><span class="comment">//</span></span>
<a id="line7"></a><span class="lineno"> 7</span><span class="line">#ifndef Synopsis_TypeAnalysis_TypeEvaluator_hh_</span>
<a id="line8"></a><span class="lineno"> 8</span><span class="line">#define Synopsis_TypeAnalysis_TypeEvaluator_hh_</span>
<a id="line9"></a><span class="lineno"> 9</span>
<a id="line10"></a><span class="lineno">10</span><span class="line">#include &lt;Synopsis/PTree/Visitor.hh&gt;</span>
<a id="line11"></a><span class="lineno">11</span><span class="line">#include &lt;Synopsis/PTree/Atoms.hh&gt;</span>
<a id="line12"></a><span class="lineno">12</span><span class="line">#include &lt;Synopsis/PTree/Lists.hh&gt;</span>
<a id="line13"></a><span class="lineno">13</span><span class="line">#include &lt;Synopsis/SymbolLookup/Scope.hh&gt;</span>
<a id="line14"></a><span class="lineno">14</span><span class="line">#include &lt;Synopsis/TypeAnalysis/Type.hh&gt;</span>
<a id="line15"></a><span class="lineno">15</span>
<a id="line16"></a><span class="lineno">16</span><span class="line"><span class="keyword">namespace</span> <a href="../../../Scopes/Synopsis.html" title="namespace Synopsis">Synopsis</a></span>
<a id="line17"></a><span class="lineno">17</span><span class="line">{</span>
<a id="line18"></a><span class="lineno">18</span><span class="line"><span class="keyword">namespace</span> <a href="../../../Scopes/Synopsis/TypeAnalysis.html" title="namespace Synopsis::TypeAnalysis">TypeAnalysis</a></span>
<a id="line19"></a><span class="lineno">19</span><span class="line">{</span>
<a id="line20"></a><span class="lineno">20</span>
<a id="line21"></a><span class="lineno">21</span><span class="line"><span class="comment">//. evaluate the type of an expression</span></span>
<a id="line22"></a><span class="lineno">22</span><span class="line"><span class="keyword">class</span> <a href="../../../Scopes/Synopsis/TypeAnalysis/TypeEvaluator.html" title="class Synopsis::TypeAnalysis::TypeEvaluator">TypeEvaluator</a> : <span class="keyword">private</span> <a href="../../../Scopes/Synopsis/PTree/Visitor.html" title="class Synopsis::PTree::Visitor">PTree::Visitor</a></span>
<a id="line23"></a><span class="lineno">23</span><span class="line">{</span>
<a id="line24"></a><span class="lineno">24</span><span class="line"><span class="keyword">public</span>:</span>
<a id="line25"></a><span class="lineno">25</span><span class="line">  <a href="" title="member function Synopsis::TypeAnalysis::TypeEvaluator::TypeEvaluator(const SymbolLookup::Scope*)">TypeEvaluator</a>(<a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html" title="class Synopsis::SymbolLookup::Scope">SymbolLookup::Scope const</a> *s) : my_scope(s) {}</span>
<a id="line26"></a><span class="lineno">26</span><span class="line">  <a href="../../../Scopes/Synopsis/TypeAnalysis/Type.html" title="class Synopsis::TypeAnalysis::Type">Type const</a> *<a href="" title="member function Synopsis::TypeAnalysis::TypeEvaluator::evaluate(const PTree::Node*)">evaluate</a>(<a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node const</a> *node);</span>
<a id="line27"></a><span class="lineno">27</span>
<a id="line28"></a><span class="lineno">28</span><span class="line"><span class="keyword">private</span>:</span>
<a id="line29"></a><span class="lineno">29</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::TypeAnalysis::TypeEvaluator::visit(PTree::Literal*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Literal.html" title="class Synopsis::PTree::Literal">PTree::Literal</a> *);</span>
<a id="line30"></a><span class="lineno">30</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::TypeAnalysis::TypeEvaluator::visit(PTree::Identifier*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Identifier.html" title="class Synopsis::PTree::Identifier">PTree::Identifier</a> *);</span>
<a id="line31"></a><span class="lineno">31</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::TypeAnalysis::TypeEvaluator::visit(PTree::Kwd::This*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Kwd.html#This" title="typedef Synopsis::PTree::Kwd::This">PTree::Kwd::This</a> *);</span>
<a id="line32"></a><span class="lineno">32</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::TypeAnalysis::TypeEvaluator::visit(PTree::Name*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Name.html" title="class Synopsis::PTree::Name">PTree::Name</a> *);</span>
<a id="line33"></a><span class="lineno">33</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::TypeAnalysis::TypeEvaluator::visit(PTree::FstyleCastExpr*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/FstyleCastExpr.html" title="class Synopsis::PTree::FstyleCastExpr">PTree::FstyleCastExpr</a> *);</span>
<a id="line34"></a><span class="lineno">34</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::TypeAnalysis::TypeEvaluator::visit(PTree::AssignExpr*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/AssignExpr.html" title="class Synopsis::PTree::AssignExpr">PTree::AssignExpr</a> *);</span>
<a id="line35"></a><span class="lineno">35</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::TypeAnalysis::TypeEvaluator::visit(PTree::CondExpr*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/CondExpr.html" title="class Synopsis::PTree::CondExpr">PTree::CondExpr</a> *);</span>
<a id="line36"></a><span class="lineno">36</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::TypeAnalysis::TypeEvaluator::visit(PTree::InfixExpr*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/InfixExpr.html" title="class Synopsis::PTree::InfixExpr">PTree::InfixExpr</a> *);</span>
<a id="line37"></a><span class="lineno">37</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::TypeAnalysis::TypeEvaluator::visit(PTree::PmExpr*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/PmExpr.html" title="class Synopsis::PTree::PmExpr">PTree::PmExpr</a> *);</span>
<a id="line38"></a><span class="lineno">38</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::TypeAnalysis::TypeEvaluator::visit(PTree::CastExpr*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/CastExpr.html" title="class Synopsis::PTree::CastExpr">PTree::CastExpr</a> *);</span>
<a id="line39"></a><span class="lineno">39</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::TypeAnalysis::TypeEvaluator::visit(PTree::UnaryExpr*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/UnaryExpr.html" title="class Synopsis::PTree::UnaryExpr">PTree::UnaryExpr</a> *);</span>
<a id="line40"></a><span class="lineno">40</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::TypeAnalysis::TypeEvaluator::visit(PTree::ThrowExpr*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/ThrowExpr.html" title="class Synopsis::PTree::ThrowExpr">PTree::ThrowExpr</a> *);</span>
<a id="line41"></a><span class="lineno">41</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::TypeAnalysis::TypeEvaluator::visit(PTree::SizeofExpr*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/SizeofExpr.html" title="class Synopsis::PTree::SizeofExpr">PTree::SizeofExpr</a> *);</span>
<a id="line42"></a><span class="lineno">42</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::TypeAnalysis::TypeEvaluator::visit(PTree::TypeidExpr*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/TypeidExpr.html" title="class Synopsis::PTree::TypeidExpr">PTree::TypeidExpr</a> *);</span>
<a id="line43"></a><span class="lineno">43</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::TypeAnalysis::TypeEvaluator::visit(PTree::TypeofExpr*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/TypeofExpr.html" title="class Synopsis::PTree::TypeofExpr">PTree::TypeofExpr</a> *);</span>
<a id="line44"></a><span class="lineno">44</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::TypeAnalysis::TypeEvaluator::visit(PTree::NewExpr*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/NewExpr.html" title="class Synopsis::PTree::NewExpr">PTree::NewExpr</a> *);</span>
<a id="line45"></a><span class="lineno">45</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::TypeAnalysis::TypeEvaluator::visit(PTree::DeleteExpr*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/DeleteExpr.html" title="class Synopsis::PTree::DeleteExpr">PTree::DeleteExpr</a> *);</span>
<a id="line46"></a><span class="lineno">46</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::TypeAnalysis::TypeEvaluator::visit(PTree::ArrayExpr*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/ArrayExpr.html" title="class Synopsis::PTree::ArrayExpr">PTree::ArrayExpr</a> *);</span>
<a id="line47"></a><span class="lineno">47</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::TypeAnalysis::TypeEvaluator::visit(PTree::FuncallExpr*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/FuncallExpr.html" title="class Synopsis::PTree::FuncallExpr">PTree::FuncallExpr</a> *);</span>
<a id="line48"></a><span class="lineno">48</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::TypeAnalysis::TypeEvaluator::visit(PTree::PostfixExpr*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/PostfixExpr.html" title="class Synopsis::PTree::PostfixExpr">PTree::PostfixExpr</a> *);</span>
<a id="line49"></a><span class="lineno">49</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::TypeAnalysis::TypeEvaluator::visit(PTree::DotMemberExpr*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/DotMemberExpr.html" title="class Synopsis::PTree::DotMemberExpr">PTree::DotMemberExpr</a> *);</span>
<a id="line50"></a><span class="lineno">50</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::TypeAnalysis::TypeEvaluator::visit(PTree::ArrowMemberExpr*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/ArrowMemberExpr.html" title="class Synopsis::PTree::ArrowMemberExpr">PTree::ArrowMemberExpr</a> *);</span>
<a id="line51"></a><span class="lineno">51</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::TypeAnalysis::TypeEvaluator::visit(PTree::ParenExpr*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/ParenExpr.html" title="class Synopsis::PTree::ParenExpr">PTree::ParenExpr</a> *);</span>
<a id="line52"></a><span class="lineno">52</span><span class="line">  </span>
<a id="line53"></a><span class="lineno">53</span><span class="line">  <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html" title="class Synopsis::SymbolLookup::Scope">SymbolLookup::Scope const</a> *<a href="../../../Scopes/Synopsis/TypeAnalysis/TypeEvaluator.html#my_scope" title="data member Synopsis::TypeAnalysis::TypeEvaluator::my_scope">my_scope</a>;</span>
<a id="line54"></a><span class="lineno">54</span><span class="line">  <a href="../../../Scopes/Synopsis/TypeAnalysis/Type.html" title="class Synopsis::TypeAnalysis::Type">Type const</a> *               <a href="../../../Scopes/Synopsis/TypeAnalysis/TypeEvaluator.html#my_type" title="data member Synopsis::TypeAnalysis::TypeEvaluator::my_type">my_type</a>;</span>
<a id="line55"></a><span class="lineno">55</span><span class="line">};</span>
<a id="line56"></a><span class="lineno">56</span><span class="line">  </span>
<a id="line57"></a><span class="lineno">57</span><span class="line">inline <a href="../../../Scopes/Synopsis/TypeAnalysis/Type.html" title="class Synopsis::TypeAnalysis::Type">Type const</a> *<a href="" title="function Synopsis::TypeAnalysis::type_of(const PTree::Node*,const SymbolLookup::Scope*)">type_of</a>(<a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node const</a> *node,</span>
<a id="line58"></a><span class="lineno">58</span><span class="line">			   <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html" title="class Synopsis::SymbolLookup::Scope">SymbolLookup::Scope const</a> *s)</span>
<a id="line59"></a><span class="lineno">59</span><span class="line">{</span>
<a id="line60"></a><span class="lineno">60</span><span class="line">  <a href="../../../Scopes/Synopsis/TypeAnalysis/TypeEvaluator.html" title="class Synopsis::TypeAnalysis::TypeEvaluator">TypeEvaluator</a> <a href="" title="local variable evaluator">evaluator</a>(s);</span>
<a id="line61"></a><span class="lineno">61</span><span class="line">  <span class="keyword">return</span> <a href="" title="local variable evaluator">evaluator</a>.<a href="" title="member function Synopsis::TypeAnalysis::TypeEvaluator::evaluate(const PTree::Node*)">evaluate</a>(<a href="" title="parameter node">node</a>);</span>
<a id="line62"></a><span class="lineno">62</span><span class="line">}</span>
<a id="line63"></a><span class="lineno">63</span>
<a id="line64"></a><span class="lineno">64</span><span class="line">}</span>
<a id="line65"></a><span class="lineno">65</span><span class="line">}</span>
<a id="line66"></a><span class="lineno">66</span>
<a id="line67"></a><span class="lineno">67</span><span class="line">#endif</span>
<a id="line68"></a><span class="lineno">68</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:28:05 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
